stash: remove now superfluos help for "stash push"
[git.git] / git-stash.sh
blob4b7495144013b6a224571376a411cdcbcfd055aa
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
15 or: $dashless clear"
17 SUBDIRECTORY_OK=Yes
18 OPTIONS_SPEC=
19 START_DIR=$(pwd)
20 . git-sh-setup
21 require_work_tree
22 prefix=$(git rev-parse --show-prefix) || exit 1
23 cd_to_toplevel
25 TMP="$GIT_DIR/.git-stash.$$"
26 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
29 ref_stash=refs/stash
31 if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34 else
35 help_color=
36 reset_color=
39 no_changes () {
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" || test -z "$(untracked_files)")
45 untracked_files () {
46 if test "$1" = "-z"
47 then
48 shift
49 z=-z
50 else
53 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
55 git ls-files -o $z $excl_opt -- "$@"
58 clear_stash () {
59 if test $# != 0
60 then
61 die "$(gettext "git stash clear with parameters is unimplemented")"
63 if current=$(git rev-parse --verify --quiet $ref_stash)
64 then
65 git update-ref -d $ref_stash $current
69 create_stash () {
70 stash_msg=
71 untracked=
72 while test $# != 0
74 case "$1" in
75 -m|--message)
76 shift
77 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
79 -u|--include-untracked)
80 shift
81 untracked=${1?"BUG: create_stash () -u requires an argument"}
83 --)
84 shift
85 break
87 esac
88 shift
89 done
91 git update-index -q --refresh
92 if no_changes "$@"
93 then
94 exit 0
97 # state of the base commit
98 if b_commit=$(git rev-parse --verify HEAD)
99 then
100 head=$(git rev-list --oneline -n 1 HEAD --)
101 else
102 die "$(gettext "You do not have the initial commit yet")"
105 if branch=$(git symbolic-ref -q HEAD)
106 then
107 branch=${branch#refs/heads/}
108 else
109 branch='(no branch)'
111 msg=$(printf '%s: %s' "$branch" "$head")
113 # state of the index
114 i_tree=$(git write-tree) &&
115 i_commit=$(printf 'index on %s\n' "$msg" |
116 git commit-tree $i_tree -p $b_commit) ||
117 die "$(gettext "Cannot save the current index state")"
119 if test -n "$untracked"
120 then
121 # Untracked files are stored by themselves in a parentless commit, for
122 # ease of unpacking later.
123 u_commit=$(
124 untracked_files -z "$@" | (
125 GIT_INDEX_FILE="$TMPindex" &&
126 export GIT_INDEX_FILE &&
127 rm -f "$TMPindex" &&
128 git update-index -z --add --remove --stdin &&
129 u_tree=$(git write-tree) &&
130 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
131 rm -f "$TMPindex"
132 ) ) || die "$(gettext "Cannot save the untracked files")"
134 untracked_commit_option="-p $u_commit";
135 else
136 untracked_commit_option=
139 if test -z "$patch_mode"
140 then
142 # state of the working tree
143 w_tree=$( (
144 git read-tree --index-output="$TMPindex" -m $i_tree &&
145 GIT_INDEX_FILE="$TMPindex" &&
146 export GIT_INDEX_FILE &&
147 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
148 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
149 git write-tree &&
150 rm -f "$TMPindex"
151 ) ) ||
152 die "$(gettext "Cannot save the current worktree state")"
154 else
156 rm -f "$TMP-index" &&
157 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
159 # find out what the user wants
160 GIT_INDEX_FILE="$TMP-index" \
161 git add--interactive --patch=stash -- "$@" &&
163 # state of the working tree
164 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
165 die "$(gettext "Cannot save the current worktree state")"
167 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
168 test -s "$TMP-patch" ||
169 die "$(gettext "No changes selected")"
171 rm -f "$TMP-index" ||
172 die "$(gettext "Cannot remove temporary index (can't happen)")"
176 # create the stash
177 if test -z "$stash_msg"
178 then
179 stash_msg=$(printf 'WIP on %s' "$msg")
180 else
181 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
183 w_commit=$(printf '%s\n' "$stash_msg" |
184 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185 die "$(gettext "Cannot record working tree state")"
188 store_stash () {
189 while test $# != 0
191 case "$1" in
192 -m|--message)
193 shift
194 stash_msg="$1"
196 -q|--quiet)
197 quiet=t
200 break
202 esac
203 shift
204 done
205 test $# = 1 ||
206 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
208 w_commit="$1"
209 if test -z "$stash_msg"
210 then
211 stash_msg="Created via \"git stash store\"."
214 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
215 ret=$?
216 test $ret != 0 && test -z "$quiet" &&
217 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
218 return $ret
221 push_stash () {
222 keep_index=
223 patch_mode=
224 untracked=
225 stash_msg=
226 while test $# != 0
228 case "$1" in
229 -k|--keep-index)
230 keep_index=t
232 --no-keep-index)
233 keep_index=n
235 -p|--patch)
236 patch_mode=t
237 # only default to keep if we don't already have an override
238 test -z "$keep_index" && keep_index=t
240 -q|--quiet)
241 GIT_QUIET=t
243 -u|--include-untracked)
244 untracked=untracked
246 -a|--all)
247 untracked=all
249 -m|--message)
250 shift
251 test -z ${1+x} && usage
252 stash_msg=$1
254 --help)
255 show_help
258 shift
259 break
262 option="$1"
263 eval_gettextln "error: unknown option for 'stash push': \$option"
264 usage
267 break
269 esac
270 shift
271 done
273 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
275 if test -n "$patch_mode" && test -n "$untracked"
276 then
277 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
280 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
282 git update-index -q --refresh
283 if no_changes "$@"
284 then
285 say "$(gettext "No local changes to save")"
286 exit 0
289 git reflog exists $ref_stash ||
290 clear_stash || die "$(gettext "Cannot initialize stash")"
292 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
293 store_stash -m "$stash_msg" -q $w_commit ||
294 die "$(gettext "Cannot save the current status")"
295 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
297 if test -z "$patch_mode"
298 then
299 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
300 if test -n "$untracked"
301 then
302 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
305 if test $# != 0
306 then
307 git reset -q -- "$@"
308 git ls-files -z --modified -- "$@" |
309 git checkout-index -z --force --stdin
310 git clean --force -q -d -- "$@"
311 else
312 git reset --hard -q
315 if test "$keep_index" = "t" && test -n "$i_tree"
316 then
317 git read-tree --reset $i_tree
318 git ls-files -z --modified -- "$@" |
319 git checkout-index -z --force --stdin
321 else
322 git apply -R < "$TMP-patch" ||
323 die "$(gettext "Cannot remove worktree changes")"
325 if test "$keep_index" != "t"
326 then
327 git reset -q -- "$@"
332 save_stash () {
333 push_options=
334 while test $# != 0
336 case "$1" in
338 shift
339 break
342 # pass all options through to push_stash
343 push_options="$push_options $1"
346 break
348 esac
349 shift
350 done
352 stash_msg="$*"
354 if test -z "$stash_msg"
355 then
356 push_stash $push_options
357 else
358 push_stash $push_options -m "$stash_msg"
362 have_stash () {
363 git rev-parse --verify --quiet $ref_stash >/dev/null
366 list_stash () {
367 have_stash || return 0
368 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
371 show_stash () {
372 ALLOW_UNKNOWN_FLAGS=t
373 assert_stash_like "$@"
375 if test -z "$FLAGS"
376 then
377 if test "$(git config --bool stash.showStat || echo true)" = "true"
378 then
379 FLAGS=--stat
382 if test "$(git config --bool stash.showPatch || echo false)" = "true"
383 then
384 FLAGS=${FLAGS}${FLAGS:+ }-p
387 if test -z "$FLAGS"
388 then
389 return 0
393 git diff ${FLAGS} $b_commit $w_commit
396 show_help () {
397 exec git help stash
398 exit 1
402 # Parses the remaining options looking for flags and
403 # at most one revision defaulting to ${ref_stash}@{0}
404 # if none found.
406 # Derives related tree and commit objects from the
407 # revision, if one is found.
409 # stash records the work tree, and is a merge between the
410 # base commit (first parent) and the index tree (second parent).
412 # REV is set to the symbolic version of the specified stash-like commit
413 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
414 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
415 # s is set to the SHA1 of the stash commit
416 # w_commit is set to the commit containing the working tree
417 # b_commit is set to the base commit
418 # i_commit is set to the commit containing the index tree
419 # u_commit is set to the commit containing the untracked files tree
420 # w_tree is set to the working tree
421 # b_tree is set to the base tree
422 # i_tree is set to the index tree
423 # u_tree is set to the untracked files tree
425 # GIT_QUIET is set to t if -q is specified
426 # INDEX_OPTION is set to --index if --index is specified.
427 # FLAGS is set to the remaining flags (if allowed)
429 # dies if:
430 # * too many revisions specified
431 # * no revision is specified and there is no stash stack
432 # * a revision is specified which cannot be resolve to a SHA1
433 # * a non-existent stash reference is specified
434 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
437 parse_flags_and_rev()
439 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
440 PARSE_CACHE="$*"
442 IS_STASH_LIKE=
443 IS_STASH_REF=
444 INDEX_OPTION=
446 w_commit=
447 b_commit=
448 i_commit=
449 u_commit=
450 w_tree=
451 b_tree=
452 i_tree=
453 u_tree=
455 FLAGS=
456 REV=
457 for opt
459 case "$opt" in
460 -q|--quiet)
461 GIT_QUIET=-t
463 --index)
464 INDEX_OPTION=--index
466 --help)
467 show_help
470 test "$ALLOW_UNKNOWN_FLAGS" = t ||
471 die "$(eval_gettext "unknown option: \$opt")"
472 FLAGS="${FLAGS}${FLAGS:+ }$opt"
475 REV="${REV}${REV:+ }'$opt'"
477 esac
478 done
480 eval set -- $REV
482 case $# in
484 have_stash || die "$(gettext "No stash entries found.")"
485 set -- ${ref_stash}@{0}
491 die "$(eval_gettext "Too many revisions specified: \$REV")"
493 esac
495 case "$1" in
496 *[!0-9]*)
500 set -- "${ref_stash}@{$1}"
502 esac
504 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
505 reference="$1"
506 die "$(eval_gettext "\$reference is not a valid reference")"
509 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
510 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
511 s=$1 &&
512 w_commit=$1 &&
513 b_commit=$2 &&
514 w_tree=$3 &&
515 b_tree=$4 &&
516 i_tree=$5 &&
517 IS_STASH_LIKE=t &&
518 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
519 IS_STASH_REF=t
521 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
522 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
525 is_stash_like()
527 parse_flags_and_rev "$@"
528 test -n "$IS_STASH_LIKE"
531 assert_stash_like() {
532 is_stash_like "$@" || {
533 args="$*"
534 die "$(eval_gettext "'\$args' is not a stash-like commit")"
538 is_stash_ref() {
539 is_stash_like "$@" && test -n "$IS_STASH_REF"
542 assert_stash_ref() {
543 is_stash_ref "$@" || {
544 args="$*"
545 die "$(eval_gettext "'\$args' is not a stash reference")"
549 apply_stash () {
551 assert_stash_like "$@"
553 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
555 # current index state
556 c_tree=$(git write-tree) ||
557 die "$(gettext "Cannot apply a stash in the middle of a merge")"
559 unstashed_index_tree=
560 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
561 test "$c_tree" != "$i_tree"
562 then
563 git diff-tree --binary $s^2^..$s^2 | git apply --cached
564 test $? -ne 0 &&
565 die "$(gettext "Conflicts in index. Try without --index.")"
566 unstashed_index_tree=$(git write-tree) ||
567 die "$(gettext "Could not save index tree")"
568 git reset
571 if test -n "$u_tree"
572 then
573 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
574 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
575 rm -f "$TMPindex" ||
576 die "$(gettext "Could not restore untracked files from stash entry")"
579 eval "
580 GITHEAD_$w_tree='Stashed changes' &&
581 GITHEAD_$c_tree='Updated upstream' &&
582 GITHEAD_$b_tree='Version stash was based on' &&
583 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
586 if test -n "$GIT_QUIET"
587 then
588 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
590 if git merge-recursive $b_tree -- $c_tree $w_tree
591 then
592 # No conflict
593 if test -n "$unstashed_index_tree"
594 then
595 git read-tree "$unstashed_index_tree"
596 else
597 a="$TMP-added" &&
598 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
599 git read-tree --reset $c_tree &&
600 git update-index --add --stdin <"$a" ||
601 die "$(gettext "Cannot unstage modified files")"
602 rm -f "$a"
604 squelch=
605 if test -n "$GIT_QUIET"
606 then
607 squelch='>/dev/null 2>&1'
609 (cd "$START_DIR" && eval "git status $squelch") || :
610 else
611 # Merge conflict; keep the exit status from merge-recursive
612 status=$?
613 git rerere
614 if test -n "$INDEX_OPTION"
615 then
616 gettextln "Index was not unstashed." >&2
618 exit $status
622 pop_stash() {
623 assert_stash_ref "$@"
625 if apply_stash "$@"
626 then
627 drop_stash "$@"
628 else
629 status=$?
630 say "$(gettext "The stash entry is kept in case you need it again.")"
631 exit $status
635 drop_stash () {
636 assert_stash_ref "$@"
638 git reflog delete --updateref --rewrite "${REV}" &&
639 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
640 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
642 # clear_stash if we just dropped the last stash entry
643 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
644 clear_stash
647 apply_to_branch () {
648 test -n "$1" || die "$(gettext "No branch name specified")"
649 branch=$1
650 shift 1
652 set -- --index "$@"
653 assert_stash_like "$@"
655 git checkout -b $branch $REV^ &&
656 apply_stash "$@" && {
657 test -z "$IS_STASH_REF" || drop_stash "$@"
661 test "$1" = "-p" && set "push" "$@"
663 PARSE_CACHE='--not-parsed'
664 # The default command is "push" if nothing but options are given
665 seen_non_option=
666 for opt
668 case "$opt" in
669 --) break ;;
670 -*) ;;
671 *) seen_non_option=t; break ;;
672 esac
673 done
675 test -n "$seen_non_option" || set "push" "$@"
677 # Main command set
678 case "$1" in
679 list)
680 shift
681 list_stash "$@"
683 show)
684 shift
685 show_stash "$@"
687 save)
688 shift
689 save_stash "$@"
691 push)
692 shift
693 push_stash "$@"
695 apply)
696 shift
697 apply_stash "$@"
699 clear)
700 shift
701 clear_stash "$@"
703 create)
704 shift
705 create_stash -m "$*" && echo "$w_commit"
707 store)
708 shift
709 store_stash "$@"
711 drop)
712 shift
713 drop_stash "$@"
715 pop)
716 shift
717 pop_stash "$@"
719 branch)
720 shift
721 apply_to_branch "$@"
724 case $# in
726 push_stash &&
727 say "$(gettext "(To restore them type \"git stash apply\")")"
730 usage
731 esac
733 esac